apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: pkgbuild-deb
  namespace: {{ buildns }}
spec:
  params:
  - default: {{ (opsimages | json_query("[?name=='jkagdeb'].image"))[0] }}
    description: Debian Packages Builder Base Image
    name: baseimage
    type: string
  - default: "{{ nexus_api_address | default('') }}"
    description: Nexus Repository Address
    name: nexusaddress
    type: string
  - default: "{{ nexus_deb_repository | default('debian') }}"
    description: Nexus APT Repository Name
    name: nexusrepo
    type: string
  steps:
  - args:
    - -c
    - |
        . /usr/local/bin/set_runtime
        pkgname=`head -1 debian/changelog | awk '{print $1}'`
        git rev-parse --short HEAD >gitHash
        make createinitialarchive
        make createdebbin
        cat debian/changelog | awk "/$pkgname/{print \$2;exit}" | sed -e 's|[()]||g' -e 's|.*-\\([0-9]*\\)\$|\\1|' >patchNumber
        cat debian/changelog | awk "/$pkgname/{print \$2;exit}" | sed -e 's|[()]||g' -e 's|\\(.*\\)-[0-9]*\$|\\1|' >versionNumber
        if test "$NEXUS_USER" -a "$NEXUS_PASS"; then
            find ../ -type f -name '*.deb' | while read f
                do
                    curl -u "$NEXUS_USER:$NEXUS_PASS" -k -X POST -H "Content-Type: multipart/form-data" --data-binary "@$f" \
                        "$(params.nexusaddress)/repository/$(params.nexusrepo)/"
                done
        fi
    command:
    - /bin/sh
    env:
    - name: NEXUS_PASS
      valueFrom:
        secretKeyRef:
          name: "{{ nexus_artifacts_secret | default('artifacts') }}"
          key: password
          optional: true
    - name: NEXUS_USER
      valueFrom:
        secretKeyRef:
          name: "{{ nexus_artifacts_secret | default('artifacts') }}"
          key: username
          optional: true
    image: $(params.baseimage)
    name: build
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_pkgbuild_cpu_limit }}"
        memory: {{ tekton_pkgbuild_memory_limit }}
      requests:
        cpu: "{{ tekton_pkgbuild_cpu_request }}"
        memory: {{ tekton_pkgbuild_memory_request }}
{% else %}
    resources: {}
{% endif %}
    workingDir: "$(workspaces.source.path)"
  workspaces:
  - name: source
